SystemOrganization addCategory: #TinyBlog!
SystemOrganization addCategory: 'TinyBlog-Test'!

TestCase subclass: #TBBlogTest
	instanceVariableNames: 'blog post first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Test'!

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:03'!
setUp
	blog := TBBlog current.
	blog removeAllPosts.
	
	first:= TBPost title: 'A title' text:'A text' category:'First Category'.
	blog writeBlogPost: first.
	
	post:= (TBPost title:'Another title' text:'Another Text' category:'Second Category') beVisible.
	
	

! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:03'!
tearDown
	TBBlog reset! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:06'!
testAddBlogPost
	blog writeBlogPost: post.
	self assert: blog size equals: 2! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:20'!
testAllBlogPosts
	blog writeBlogPost: post.
	self assert: blog allBlogPosts size equals: 2! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:25'!
testAllBlogPostsFromCategory
	self assert: (blog allBlogPostsFromCategory: 'First Category') size equals: 1! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:38'!
testAllCategories
	blog writeBlogPost: post.
	self assert: blog allCategories size equals: 2
! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:28'!
testAllVisibleBlogPostsFromCategory
	blog writeBlogPost: post.
	self assert: (blog allVisibleBlogPostsFromCategory: 'First Category') size equals: 0.
	self assert: (blog allVisibleBlogPostsFromCategory: 'Second Category') size equals: 1
! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:21'!
testAllVisiblePosts
	blog writeBlogPost: post.
	self assert: blog allVisibleBlogPosts size equals: 1! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:16'!
testRemoveAllBlogPost
	blog removeAllPosts.
	self assert:  blog size equals: 0 ! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:13'!
testSize
self assert: blog size equals: 1! !

!TBBlogTest methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:36'!
testUnclassifiedBlogPosts
self assert: (blog allBlogPosts select: [ :p | p isUnclassified]) size equals: 0
! !

Object subclass: #TBBlog
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog'!

TBBlog class
	instanceVariableNames: 'uniqueInstance'!

TBBlog class
	instanceVariableNames: 'uniqueInstance'!

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:43'!
createDemoPosts
"TBBlog createDemoPosts"
self current
writeBlogPost: ((TBPost title: 'Welcome in TinyBlog' text:'TinyBlog is a small blog engine made with Pharo.' category:'TinyBlog') visible: true);

writeBlogPost: ((TBPost title: 'Report Pharo Sprint' text:'Friday, June 12 there was a Pharo sprint / Moose dojo. It was a nice event with more than 15 motivated sprinters. With the help of candies, cakes and chocolate, huge work has been done' category: 'Pharo') visible: true);

writeBlogPost: ((TBPost title: 'Brick on top of Bloc -Preview' text: 'We are happy to announce the first preview version of Brick, a new widget set created from scratch on top of Bloc. Brick is being developed primarily by Alex Syrel (together with Alain Plantec, Andrei Chis and myself), and the work is sponsored by ESUG. Brick is part of the Glamorous Toolkit effort and will provide the basis for the new versions of the development tools.' category: 'Pharo') visible: true);

writeBlogPost: ((TBPost title: 'The sad story of unclassified blog posts' text: 'So sad that I can read this.') visible: true);

writeBlogPost: ((TBPost title: 'Working with Pharo on theRaspberry Pi' text: 'Hardware is getting cheaper and many new small devices like the famous Raspberry Pi provide new computation power that was one once only available on regular desktop computers.' category: 'Pharo') visible: true)
! !

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 13:21'!
current
"answer the instance of the TBRepository"
^ uniqueInstance ifNil: [ uniqueInstance := self new ]

! !

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 13:21'!
initialize
	self reset

! !

TBBlog initialize!

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 13:19'!
reset
	uniqueInstance := nil
! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:20'!
allBlogPosts
	^posts! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:27'!
allBlogPostsFromCategory: aCategory
	 ^ posts select: [ :p | p category= aCategory  ]! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:39'!
allCategories
	^ (self allBlogPosts collect: [ :p | p category ]) asSet
! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:23'!
allVisibleBlogPosts
	^ posts select: [ :p| p isVisible  ]! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:30'!
allVisibleBlogPostsFromCategory: aCategory
	^ posts select: [ :p | p category = aCategory and: [ p isVisible] ]
! !

!TBBlog methodsFor: 'initialize' stamp: 'OscarAmelunge 6/19/2016 13:17'!
initialize
	super initialize.
	posts := OrderedCollection new.
! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:07'!
removeAllPosts
	posts := OrderedCollection new ! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:11'!
size
	^ posts size! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:08'!
writeBlogPost: aPost 
	"write a blog post on data base"
	posts add: aPost! !

Object subclass: #TBPost
	instanceVariableNames: 'title text date category visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog'!

!TBPost class methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 12:55'!
title: aTitle text: aText
	^ self new
	title: aTitle;
	text: aText;
	yourself ! !

!TBPost class methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 12:55'!
title: aTitle text: aText category: aCategory
^ (self title: aTitle text: aText)
	category: aCategory;
	yourself
! !

!TBPost class methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 12:52'!
unclassifiedTag
	^ 'Unclassified'
! !

!TBPost methodsFor: 'action' stamp: 'OscarAmelunge 6/19/2016 12:49'!
beVisible
	self visible: true! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:46'!
category
	^ category! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:46'!
category: anObject
	category := anObject! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:45'!
date
	^ date! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:45'!
date: anObject
	date := anObject
! !

!TBPost methodsFor: 'initialize' stamp: 'OscarAmelunge 6/19/2016 12:53'!
initialize
	self category: TBPost unclassifiedTag.
	self date: Date today.
	self notVisible! !

!TBPost methodsFor: 'as yet unclassified' stamp: 'OscarAmelunge 6/19/2016 14:38'!
isUnclassified
	^ self category = TBPost unclassifiedTag
! !

!TBPost methodsFor: 'action' stamp: 'OscarAmelunge 6/19/2016 12:49'!
isVisible
	^ self visible! !

!TBPost methodsFor: 'action' stamp: 'OscarAmelunge 6/19/2016 12:49'!
notVisible
	self visible: false! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:45'!
text
	^ text! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:45'!
text: anObject
	text := anObject! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:44'!
title
^ title! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:44'!
title: anObject
	title := anObject! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:46'!
visible
	^ visible
! !

!TBPost methodsFor: 'acccessing' stamp: 'OscarAmelunge 6/19/2016 12:46'!
visible: anObject
	visible := anObject! !

TBBlog initialize!
